<%--

This primarily demonstrates how FreeMarker now can load its templates from OpenCms' virtual filesystem.
It differs from example 1 in that it uses the templating abstraction provided by the optional
com.codedroids.oc.forms module (which of course needs to be installed for this example to run)

--%>
<%@ 
page session="false" %><%@ 
page import="java.util.*,java.io.*" %><%@ 
page import="org.opencms.jsp.*, org.opencms.file.*" %><%@ 
page import="com.codedroids.templating.*, com.codedroids.oc.templating.*" %>
<%
  CmsJspActionElement cms = new CmsJspActionElement(pageContext, request, response);
  CmsObject cmso = cms.getCmsObject();
  

  // data model

  // Create the root hash
  Map root = new HashMap();
  // Put string ``user'' into the root
  root.put("user", "Big Joe");
  // Create the hash for ``latestProduct''
  Map latest = new HashMap();
  // and put it into the root
  root.put("latestProduct", latest);
  // put ``url'' and ``name'' into latest
  latest.put("url", "products/bluemouse.html");
  latest.put("name", "blue mouse");  

  String templateName = "/system/modules/com.codedroids.oc.freemarker/docs/ex1-template.html";
  A_TemplateEngine te = OCTemplateEngineFactory.templateEngine(cms, templateName, "{ engine:ftl, encoding:ISO-8859-1 }");
  te.process(root, out);
%>